package com.zswl.cloud.springBtach.server.core.api.xiaoju.sdk.util;


import java.security.Key;
import java.util.Base64;
import javax.crypto.Cipher;
import javax.crypto.SecretKey;
import javax.crypto.spec.IvParameterSpec;
import javax.crypto.spec.SecretKeySpec;

import cn.hutool.json.JSONUtil;
import org.apache.commons.codec.digest.DigestUtils;

public abstract class Encoder {
    public static String encrypt(String data, String dataSecret, String dataSecretIv) {
        try {
            if (dataSecret == null) {
                System.out.print("Key");
                return null;
            }
            if (dataSecret.length() != 16) {
                System.out.print("Key");
                return null;
            }
            byte[] raw = dataSecret.getBytes("UTF-8");
            SecretKeySpec skeySpec = new SecretKeySpec(raw, "AES");
            Cipher cipher = Cipher.getInstance("AES/CBC/PKCS5Padding");
            IvParameterSpec iv = new IvParameterSpec(dataSecretIv.getBytes());
            cipher.init(1, skeySpec, iv);
            byte[] encrypted = cipher.doFinal(data.getBytes());
            String str = Base64.getEncoder().encodeToString(encrypted);
            str = str.replaceAll("\r", "");
            str = str.replaceAll("\n", "");
            return str;
        } catch (Exception ex) {
            return null;
        }
    }

    public static String encryptH5(String dataStr, String appSecret) {
        try {
            String key = appSecret.substring(0, 16);
            Key secretKey = keyGenerator(key);
            IvParameterSpec iv = new IvParameterSpec(key.getBytes("UTF-8"));
            Cipher cipher = Cipher.getInstance("AES/CBC/PKCS5Padding");
            cipher.init(1, secretKey, iv);
            byte[] results = cipher.doFinal(dataStr.getBytes("UTF-8"));
            return Base64.getEncoder().encodeToString(results);
        } catch (Exception e) {
            System.out.println(e.getMessage());
            return null;
        }
    }

    private static SecretKey keyGenerator(String keyStr) throws Exception {
        SecretKeySpec secretKey = new SecretKeySpec(keyStr.getBytes("UTF-8"), "AES");
        return secretKey;
    }

    public static String md5Encode(Object object) {
        String body = JSONUtil.toJsonStr(object);
        return DigestUtils.md5Hex(body);
    }
}
