///*     */ package com.zswl.cloud.springBtach.server.core.api.xiaoju.sdk.request;
///*     */
///*     */ import com.xiaoju.open.oil.commons.exception.ApiRuleException;
///*     */ import com.xiaoju.open.oil.commons.utils.ParamCheckUtils;
///*     */ import com.xiaoju.open.oil.interfaces.domain.PayCodeInfo;
///*     */ import com.xiaoju.open.oil.interfaces.request.BaseOpenRequest;
//import com.xiaoju.open.oil.interfaces.response.NotificationOrderInfoResponse;
///*     */
///*     */
///*     */
///*     */
///*     */
///*     */
///*     */
///*     */
///*     */
///*     */
///*     */
///*     */
///*     */
///*     */
///*     */
///*     */
///*     */
///*     */
///*     */
///*     */
///*     */
///*     */
///*     */
///*     */
///*     */
///*     */
///*     */
///*     */
///*     */
///*     */
///*     */
///*     */
///*     */
///*     */
///*     */
///*     */
///*     */
///*     */
///*     */
///*     */
///*     */
///*     */
///*     */
///*     */
///*     */
///*     */
///*     */
///*     */
///*     */
///*     */
///*     */
///*     */
///*     */
///*     */
///*     */
///*     */
///*     */
///*     */
///*     */
///*     */
///*     */
///*     */
///*     */
///*     */
///*     */
///*     */
///*     */
///*     */
///*     */
///*     */
///*     */
///*     */
///*     */
///*     */
///*     */
///*     */
///*     */
///*     */
///*     */
///*     */
///*     */
///*     */
///*     */
///*     */
///*     */
///*     */
///*     */
///*     */
///*     */
///*     */
///*     */
///*     */
///*     */
///*     */
///*     */
///*     */
///*     */
///*     */
///*     */
///*     */ public class NotificationOrderInfoRequest
///*     */   extends BaseOpenRequest<NotificationOrderInfoResponse>
///*     */ {
///*     */   private String outUserId;
///*     */   private String orderId;
///*     */   private String cityId;
///*     */   private String cityName;
///*     */   private String storeId;
///*     */   private String storeName;
///*     */   private String itemName;
///*     */   private String gunNo;
///*     */   private Float quantity;
///*     */   private Integer totalMoney;
///*     */   private Integer realMoney;
///*     */   private Integer serviceFee;
///*     */   private Integer payStatus;
///*     */   private String payTime;
///*     */   private Integer refundStatus;
///*     */   private String refundTime;
///*     */   private Integer sourceCode;
///*     */   private String outOrderId;
///*     */   private Integer orderStatus;
///*     */   private String orderTime;
///*     */   private Integer payType;
///*     */   private String extraForOpen;
///*     */   private Integer unitPrice;
///*     */   private String openInfo;
///*     */   private PayCodeInfo payCodeDTO;
///*     */   private Integer billingType;
///*     */
///*     */   public String getApiMethodName() {
///* 137 */     return "/notifyOrderInfo";
///*     */   }
///*     */
///*     */
///*     */   public void check() throws ApiRuleException {
///* 142 */     ParamCheckUtils.checkNotEmpty(this.storeId, "storeId");
///* 143 */     ParamCheckUtils.checkNotEmpty(this.orderId, "orderId");
///* 144 */     ParamCheckUtils.checkNotEmpty(this.outUserId, "outUserId");
///* 145 */     ParamCheckUtils.checkNotEmpty(this.orderStatus, "orderStatus");
///* 146 */     ParamCheckUtils.checkNotEmpty(this.itemName, "itemName");
///* 147 */     ParamCheckUtils.checkNotEmpty(this.totalMoney, "totalMoney");
///* 148 */     ParamCheckUtils.checkNotEmpty(this.realMoney, "realMoney");
///* 149 */     ParamCheckUtils.checkNotEmpty(this.gunNo, "gunNo");
///*     */   }
///*     */
///*     */   public String getOutUserId() {
///* 153 */     return this.outUserId;
///*     */   }
///*     */
///*     */   public void setOutUserId(String outUserId) {
///* 157 */     this.outUserId = outUserId;
///*     */   }
///*     */
///*     */   public String getOrderId() {
///* 161 */     return this.orderId;
///*     */   }
///*     */
///*     */   public void setOrderId(String orderId) {
///* 165 */     this.orderId = orderId;
///*     */   }
///*     */
///*     */   public String getCityId() {
///* 169 */     return this.cityId;
///*     */   }
///*     */
///*     */   public void setCityId(String cityId) {
///* 173 */     this.cityId = cityId;
///*     */   }
///*     */
///*     */   public String getCityName() {
///* 177 */     return this.cityName;
///*     */   }
///*     */
///*     */   public void setCityName(String cityName) {
///* 181 */     this.cityName = cityName;
///*     */   }
///*     */
///*     */   public String getStoreId() {
///* 185 */     return this.storeId;
///*     */   }
///*     */
///*     */   public void setStoreId(String storeId) {
///* 189 */     this.storeId = storeId;
///*     */   }
///*     */
///*     */   public String getStoreName() {
///* 193 */     return this.storeName;
///*     */   }
///*     */
///*     */   public void setStoreName(String storeName) {
///* 197 */     this.storeName = storeName;
///*     */   }
///*     */
///*     */   public String getItemName() {
///* 201 */     return this.itemName;
///*     */   }
///*     */
///*     */   public void setItemName(String itemName) {
///* 205 */     this.itemName = itemName;
///*     */   }
///*     */
///*     */   public String getGunNo() {
///* 209 */     return this.gunNo;
///*     */   }
///*     */
///*     */   public void setGunNo(String gunNo) {
///* 213 */     this.gunNo = gunNo;
///*     */   }
///*     */
///*     */   public Float getQuantity() {
///* 217 */     return this.quantity;
///*     */   }
///*     */
///*     */   public void setQuantity(Float quantity) {
///* 221 */     this.quantity = quantity;
///*     */   }
///*     */
///*     */   public Integer getTotalMoney() {
///* 225 */     return this.totalMoney;
///*     */   }
///*     */
///*     */   public void setTotalMoney(Integer totalMoney) {
///* 229 */     this.totalMoney = totalMoney;
///*     */   }
///*     */
///*     */   public Integer getRealMoney() {
///* 233 */     return this.realMoney;
///*     */   }
///*     */
///*     */   public void setRealMoney(Integer realMoney) {
///* 237 */     this.realMoney = realMoney;
///*     */   }
///*     */
///*     */   public Integer getServiceFee() {
///* 241 */     return this.serviceFee;
///*     */   }
///*     */
///*     */   public void setServiceFee(Integer serviceFee) {
///* 245 */     this.serviceFee = serviceFee;
///*     */   }
///*     */
///*     */   public Integer getPayStatus() {
///* 249 */     return this.payStatus;
///*     */   }
///*     */
///*     */   public void setPayStatus(Integer payStatus) {
///* 253 */     this.payStatus = payStatus;
///*     */   }
///*     */
///*     */   public String getPayTime() {
///* 257 */     return this.payTime;
///*     */   }
///*     */
///*     */   public void setPayTime(String payTime) {
///* 261 */     this.payTime = payTime;
///*     */   }
///*     */
///*     */   public Integer getRefundStatus() {
///* 265 */     return this.refundStatus;
///*     */   }
///*     */
///*     */   public void setRefundStatus(Integer refundStatus) {
///* 269 */     this.refundStatus = refundStatus;
///*     */   }
///*     */
///*     */   public String getRefundTime() {
///* 273 */     return this.refundTime;
///*     */   }
///*     */
///*     */   public void setRefundTime(String refundTime) {
///* 277 */     this.refundTime = refundTime;
///*     */   }
///*     */
///*     */   public Integer getSourceCode() {
///* 281 */     return this.sourceCode;
///*     */   }
///*     */
///*     */   public void setSourceCode(Integer sourceCode) {
///* 285 */     this.sourceCode = sourceCode;
///*     */   }
///*     */
///*     */   public String getOutOrderId() {
///* 289 */     return this.outOrderId;
///*     */   }
///*     */
///*     */   public void setOutOrderId(String outOrderId) {
///* 293 */     this.outOrderId = outOrderId;
///*     */   }
///*     */
///*     */   public Integer getOrderStatus() {
///* 297 */     return this.orderStatus;
///*     */   }
///*     */
///*     */   public void setOrderStatus(Integer orderStatus) {
///* 301 */     this.orderStatus = orderStatus;
///*     */   }
///*     */
///*     */   public String getOrderTime() {
///* 305 */     return this.orderTime;
///*     */   }
///*     */
///*     */   public void setOrderTime(String orderTime) {
///* 309 */     this.orderTime = orderTime;
///*     */   }
///*     */
///*     */   public Integer getPayType() {
///* 313 */     return this.payType;
///*     */   }
///*     */
///*     */   public void setPayType(Integer payType) {
///* 317 */     this.payType = payType;
///*     */   }
///*     */
///*     */   public String getExtraForOpen() {
///* 321 */     return this.extraForOpen;
///*     */   }
///*     */
///*     */   public void setExtraForOpen(String extraForOpen) {
///* 325 */     this.extraForOpen = extraForOpen;
///*     */   }
///*     */
///*     */   public Integer getUnitPrice() {
///* 329 */     return this.unitPrice;
///*     */   }
///*     */
///*     */   public void setUnitPrice(Integer unitPrice) {
///* 333 */     this.unitPrice = unitPrice;
///*     */   }
///*     */
///*     */   public String getOpenInfo() {
///* 337 */     return this.openInfo;
///*     */   }
///*     */
///*     */   public void setOpenInfo(String openInfo) {
///* 341 */     this.openInfo = openInfo;
///*     */   }
///*     */
///*     */   public PayCodeInfo getPayCodeDTO() {
///* 345 */     return this.payCodeDTO;
///*     */   }
///*     */
///*     */   public void setPayCodeDTO(PayCodeInfo payCodeDTO) {
///* 349 */     this.payCodeDTO = payCodeDTO;
///*     */   }
///*     */
///*     */   public Integer getBillingType() {
///* 353 */     return this.billingType;
///*     */   }
///*     */
///*     */   public void setBillingType(Integer billingType) {
///* 357 */     this.billingType = billingType;
///*     */   }
///*     */ }
//
//
///* Location:              E:\chendu\MicroService\application\SpringBatchService\SpringBatchServiceServer\src\main\resources\lib\oil-sdk-jar-1.0.16.jar!\com\xiaoju\open\oil\interfaces\request\NotificationOrderInfoRequest.class
// * Java compiler version: 8 (52.0)
// * JD-Core Version:       1.1.3
// */