package com.zswl.cloud.springBtach.server.core.api.xiaoju.sdk.util;

import javax.crypto.Cipher;
import javax.crypto.spec.IvParameterSpec;
import javax.crypto.spec.SecretKeySpec;
import java.util.Base64;

public class Decoder {
  public static String decrypt(String data, String dataSecret, String dataSecretIv) {
    try {
      if (dataSecret == null) {
        System.out.print("Key为空null");
        return null;
      } 
      if (dataSecret.length() != 16) {
        System.out.print("Key长度不是16位");
        return null;
      } 
      byte[] raw = dataSecret.getBytes("UTF-8");
      SecretKeySpec skeySpec = new SecretKeySpec(raw, "AES");
      Cipher cipher = Cipher.getInstance("AES/CBC/PKCS5Padding");
      IvParameterSpec iv = new IvParameterSpec(dataSecretIv.getBytes());
      cipher.init(2, skeySpec, iv);
      byte[] encrypted1 = Base64.getDecoder().decode(data);
      try {
        byte[] original = cipher.doFinal(encrypted1);
        String originalString = new String(original, "UTF-8");
        return originalString;
      } catch (Exception e) {
        e.printStackTrace();
        return null;
      } 
    } catch (Exception ex) {
      return null;
    } 
  }
}
